## Def ##
#########

## Version

cloudversion=$(grep product.version /opt/vmware/vcloud-director/etc/global.properties | cut -d= -f2)
## VM and Location


vm=$1
moref=$(sudo -i -u postgres psql vcloud -t -c "select host_moref from vm_inv where name = '$vm';")
rpmoref=$(sudo -i -u postgres psql vcloud -t -c "select resource_pool_moref from vm_inv where name = '$vm';")
vc_id=$(sudo -i -u postgres psql vcloud -t -c "select vc_id from vm_inv where name = '$vm';")

vmmoref=$(sudo -i -u postgres psql vcloud -t -c "select moref from vm_inv where name = '$vm';") 
vmstate=$(sudo -i -u postgres psql vcloud -t -c "select state from vm_inv where name = '$vm';")
vvm=$(sudo -i -u postgres psql vcloud -t -c "select id from computevm where vmmoref = '$(echo $vmmoref)';")
vappvm=$(sudo -i -u postgres psql vcloud -t -c "select svm_id from vapp_vm where id = '$(echo $vvm)';")
computedep=$(sudo -i -u postgres psql vcloud -t -c "select deployment_status from computevm where vmmoref = '$(echo $vmmoref)';") 
depvm=$(sudo -i -u postgres psql vcloud -t -c "select date_deployed from deployed_vm where vm_id = '$(echo $vappvm)';" )

vcenter=$(sudo -i -u postgres psql vcloud -t -c "select url from virtual_center where id = '$(echo $vc_id)';" | sed 's/^[ \t]*//;/^$/d;s#^https://##;s/\(sdk\)*$//g;s:/*$::' | cut -d: -f1)
host=$(sudo -i -u postgres psql vcloud -t -c "select display_name from managed_server where moref = '$(echo $moref)';" | sed 's/^[ \t]*//;/^$/d;s#^https://##')
rp=$(sudo -i -u postgres psql vcloud -t -c "select name from resource_pool_inv where moref = '$(echo $rpmoref)';")

publicaddr=$(sudo -i -u postgres psql vcloud -t -c "select value from config where name = 'restapi.baseUri';" | sed 's/^[ \t]*//;/^$/d;s#^https://##')

maxcores=$(sudo -i -u postgres psql vcloud -t -c "select name,value from config where name = 'consoleproxy.cores.max';")

vcentername=$(sudo -i -u postgres psql vcloud -t -c "select name from virtual_center where id = '$(echo $vc_id)';")
vcenterdbthumbprint=$(sudo -i -u postgres psql vcloud -t -c "select certificate from certificate_library_item where alias = '$(echo $vcentername)';" | awk '{print substr($0, 1, length($0)-1)}' | sed '/^$/d' | sed '${s/$/-/}' | sed 's/^ *//g' | openssl x509 -noout -fingerprint)

## Ports

vcdport="T:443,8443"
vsphereport="T:443,902,903"

## Main ##
##########

## Version Check

if [[ $cloudversion =~ *"10.3.3"* ]] || [[ $cloudversion =~ *"10.4"* ]] ; then
printf "\nCloud Version is $cloudversion, need to validate Console Type\n"
legacy=$(sudo -i -u postgres psql vcloud -t -c "select is_enabled from feature_flags where name = 'LegacyConsoleProxy';")

if [[ $legacy =~ "f" ]] ; then
printf "New Console Type Enabled\n"
printf "Same endpoint($publicaddr) and port(443) as HTTP \n"
vcdport="T:443"
fi

else

printf "\nLegacy Console Type Enabled\n"
printf "Separate Certificate and Port used for Consoles \n\n"
vcdport="T:443,8443"
legacy="t"
fi

##########

## VM and Location
printf "%b" "\e[1;34m==================VM and Location==================\e[0m \n\n" 
printf "%b" "\e[1;35mVM:\e[0m $vm : $vmmoref \n"
printf "%b" "\e[1;35mDeployment Status:\e[0m $computedep\n"
printf "%b" "\e[1;35mDeployed Date:\e[0m $depvm\n"

if [[ $vmstate=="1" ]] ; then
vmstate="On"
elif [[ $vmstate!="1" ]] ; then
vmstate="Off"

fi
printf "%b" "\e[1;35mvCenter Power State:\e[0m  $vmstate\n\n"

#if [[ $vmstate=="1" ]] ; then
#$vmstate="On"


printf "%b" "\e[1;35mPublic Address:\e[0m $publicaddr\n"
printf "%b" "\e[1;35mvCenter:\e[0m $vcenter\n"
printf "%b" "\e[1;35mHost:\e[0m $host  \n"
printf "%b" "\e[1;35mResource Pool:\e[0m $rp \n"


## Validation
printf "%b" "\e[1;34m==================Validation==================\e[0m \n" 

printf "%b" "\n\e[1;35mConsole Proxy Max Cores:\e[0m $maxcores\n"


# SSL and Ports

printf "%b" "\n\e[1;35mvCenter:\e[0m $vcenter" 
printf "%b" "\n\e[1;35m=================================\e[0m"
printf "%b" "\n\e[1;36mCert\e[0m \n"
openssl s_client -connect $vcenter:443 </dev/null 2>/dev/null | openssl x509 -noout -text | egrep 'Not|DNS:' | sed -e 's/^[ \t]*//'
echo ""
livefp=$(openssl s_client -connect $vcenter:443 </dev/null 2>/dev/null | openssl x509 -noout -fingerprint)
printf "$livefp\n"
#printf "%b" "\n\e[1;36mCert from DB\e[0m \n"
printf "$vcenterdbthumbprint"

if [[ $livefp==$vcenterdbthumbprint ]] ; then
printf "%b" "\n\e[1;35m===>>> Thumbprint Matches VCD certificate_library_item DB Entry\e[0m \n\n"

elif [[ $livefp!=$vcenterdbthumbprint ]] ; then
printf "%b" "\n\e[1;35m===>>> Thumbprint Does Not Match\e[0m \n\n"

fi


printf "%b" "\n\e[1;36mNMAP\e[0m \n"
nmap -p $vsphereport $vcenter

printf "%b" "\n\n\e[1;35mHost:\e[0m $host" 
printf "%b" "\n\e[1;35m=================================\e[0m"
printf "%b" "\n\e[1;36mCert\e[0m \n"
openssl s_client -connect $host:443 </dev/null 2>/dev/null | openssl x509 -noout -text | egrep 'Not|DNS:' | sed -e 's/^[ \t]*//'
printf "%b" "\n\e[1;36mNMAP\e[0m \n"
nmap -p $vsphereport $host

 
sudo -i -u postgres psql vcloud -t -c "select name from cells where is_active = 't';" | sed 's/^[ \t]*//;/^$/d;s#^https://##' |

while read -r line
do
                cell=$line
				printf "%b" "\n\n\e[1;35mCell:\e[0m $cell"
				printf "%b" "\n\e[1;35m=================================\e[0m"
				printf "%b" "\n\e[1;36mCert 443\e[0m \n"
 				printf "%b" "\n\e[1;37mSSL to Cell\e[0m \n"                                
				openssl s_client -connect $cell:443 </dev/null 2>/dev/null | openssl x509 -noout -text | egrep 'Not|DNS:' | sed -e 's/^[ \t]*//'
				
				if [[ $legacy =~ "t" ]] ; then
                                printf "%b" "\n\e[1;36mCert 8443 Cell and Local File\e[0m \n"
				printf "%b" "\n\e[1;37mEndpoint 8443\e[0m \n"                                
				openssl s_client -connect $cell:8443 </dev/null 2>/dev/null | openssl x509 -noout -text | egrep 'Not|DNS:' | sed -e 's/^[ \t]*//'
                                echo " "
                                printf "%b" "\n\e[1;37mconsoleproxy.pem\e[0m \n"                                
                                openssl x509 -in /opt/vmware/vcloud-director/etc/user.consoleproxy.pem -noout  -text  | egrep 'Not|DNS:' | sed -e 's/^[ \t]*//'                                
                                
 				else
                                printf "%b" "\n\e[1;37mhttp.pem.pem\e[0m \n"
                                openssl x509 -in /opt/vmware/vcloud-director/etc/user.http.pem -noout  -text  | egrep 'Not|DNS:' | sed -e 's/^[ \t]*//'
                                
				fi
                                echo " "
				printf "%b" "\n\e[1;36mNMAP\e[0m \n"
				nmap -p $vcdport $cell
				
                ((i=i+1))
done

printf "%b" "\n\n\e[1;35mPublic Address:\e[0m $publicaddr" 
printf "%b" "\n\e[1;35m=================================\e[0m"
printf "%b" "\n\e[1;36mCert 443\e[0m \n"
openssl s_client -connect $publicaddr:443 </dev/null 2>/dev/null | openssl x509 -noout -text | egrep 'Not|DNS:' | sed -e 's/^[ \t]*//'

if [[ $legacy =~ "t" ]] ; then
printf "%b" "\n\e[1;36mCert 8443\e[0m \n"
openssl s_client -connect $publicaddr:8443 </dev/null 2>/dev/null | openssl x509 -noout -text | egrep 'Not|DNS:' | sed -e 's/^[ \t]*//'
fi
printf "%b" "\n\e[1;36mNMAP\e[0m \n"
nmap -p $vcdport $publicaddr

printf "\n\n DONE \n"

