cloudversion=$(grep product.version /opt/vmware/vcloud-director/etc/global.properties | cut -d= -f2)

publichttps=$(sudo -i -u postgres psql vcloud -t -c "select value from config where name = 'restapi.baseUri';")
publichttp=$(sudo -i -u postgres psql vcloud -t -c "select value from config where name = 'restapi.baseHttpUri';")
dburis=$(sudo -i -u postgres psql vcloud -t -c "select name,value from config where name in ('restapi.baseHttpUri','restapi.baseUri','ui.baseHttpUri','ui.baseUri');"| sed -e 's/^[[:space:]]*//')
eth0=$(ip a show dev eth0 | egrep 'inet' | awk '{print $2}' | sort -r | sed 's/^[ \t]*//' | cut -d/ -f 1)

#orspre=$(/opt/vmware/vcloud-director/bin/cell-management-tool manage-config -n "webapp.allowed.origins" -l)

#api="https://$HOSTNAME/"
api=$(sudo -i -u postgres psql vcloud -t -c "select value from config where name = 'restapi.baseUri';" | sed 's/^[ \t]*//;/^$/d;s#^ ##' | cut -d, -f1)
versions="/api/versions"
prov="/cloudapi/1.0.0/sessions/provider"
bearer="Authorization: Bearer "

curls="curl -ks -X"

cors="/cloudapi/1.0.0/site/settings/cors?page=1&pageSize=25"
version=$(curl -ks -X GET "$api$versions" | grep "<Version>" | grep -v "alpha" | tail -n 1 | cut -d ">" -f 2 | cut -d "<" -f 1)
accept="Accept: application/json;version=$version"

filename='token.txt'

## Main
########
printf "%b" "\e[1;34m==================Current Access Config==================\e[0m \n\n"
printf "Version: $cloudversion\n\n"

printf "%b" "\e[1;33mHostname:\e[0m $HOSTNAME\n"
printf "%b" "\e[1;33mIP:\e[0m $eth0\n"
printf "%b" "\e[1;33mPublicAddressConfig:\e[0m\n$dburis\n"

## Prior to 10.2, use CMT
#########################

if [[ $cloudversion =~ *"10.2"* ]] ; then
printf "%b" "\e[1;34m==================CORS CMT Check==================\e[0m \n\n"
printf "Obtaining Cors information from the Cell-Management-Tool Manage Config method\nPlease Wait\n"
/opt/vmware/vcloud-director/bin/cell-management-tool manage-config -n "webapp.allowed.origins" -l

## 10.3 needs to go API Route
############################

else


#printf "\nChecks\\nn"
#printf "curl -ksSL -D - -X POST\n"
#printf "$api$prov\n"
#printf "$accept\n"
#printf "-u 'administrator@system:VMware123!'\n"

#Login to get Bearer Token
curl -ksSL -D - -X POST "$api$prov" -H "$accept" -u "administrator@system:VMware123!" > headers.txt

cat headers.txt | sed -n '/X-VMWARE-VCLOUD-ACCESS-TOKEN/,/Set-Cookie/{/Set-Cookie/!p}' | cut -d" " -f 2 > token.txt


# Using token print out the current cors setting

while IFS= read -r line
do

 stripped=${line//$'\r'/}

done < "$filename"
printf "\n\n"


token="Authorization: Bearer $stripped"
printf "%b" "\e[1;34m==================CORS API Check==================\e[0m \n\n"

#printf "--Checks--\n"
#printf "$api$prov\n"
#printf "$accept\n"
#printf "\n"

#curl -ks -X GET "https:/vcd1a.vcloud.local/cloudapi/1.0.0/site/settings/cors?page=1&pageSize=25" -H "Accept: application/json;version=36.0" -H "$token"

curl -ks -X GET "$api$cors" -H "$accept" -H "$token" | python -mjson.tool | grep origin | sed -e 's/^[[:space:]]*//'
echo " "

fi




