## Definitions
##############

current=$(pwd)
pg=/opt/vmware/vpostgres/10/bin/

repmgr="sudo -u postgres /opt/vmware/vpostgres/current/bin/repmgr -f /opt/vmware/vpostgres/current/etc/repmgr.conf"
repmgr_cluster_show="${repmgr} cluster show"
repmgr_cluster_check="$repmgr cluster crosscheck"
repmgr_cluster_matrix="$repmgr cluster matrix"
repmgr_cluster_event="$repmgr cluster event"

sync_standby="grep synchronous_standby_names /var/vmware/vpostgres/10/pgdata/postgresql.conf"

nodes="ls /opt/vmware/vcloud-director/data/transfer/appliance-nodes/"

###############################
## Main
###############################
echo -e "\033[1;32mPrinting out existing Repmgr Config  \033[m"
echo " "


cd $pg

printf "%b" "\e[1;36m\nCluster Show: \e[0m\n" 
$repmgr_cluster_show

printf "%b" "\e[1;36m\nCluster Check: \e[0m\n" 
$repmgr_cluster_check

printf "%b" "\e[1;36m\nCluster Matrix: \e[0m\n" 
$repmgr_cluster_matrix

printf "%b" "\e[1;36m\nCluster Event: \e[0m\n" 
$repmgr_cluster_event


printf "%b" "\e[1;36m\nSynchronous Standbys: \e[0m\n"
$sync_standby


printf "%b" "\e[1;36m\nTransfer Node Info: \e[0m\n"

$nodes |

while read -r line
do

nodename=$(cat /opt/vmware/vcloud-director/data/transfer/appliance-nodes/$line/repmgr-node-name)
rolename=$(cat /opt/vmware/vcloud-director/data/transfer/appliance-nodes/$line/appliance-type)

                printf "\n$line\n"
		printf " - Nodename: $nodename \n"
                printf " - Role: $rolename \n\n"

done

printf "%b" "\e[1;36m\nAppliance API Node Info: \e[0m\n"

curl -ks -X GET -H "Accept: application/json" -u "root" "https://localhost:5480/api/1.0.0/nodes" | egrep 'localClusterFailover|localClusterHealth|mode|id|name|nodeHealth|nodeRole|upstream' | grep -v "dbname"

printf "%b" "\e[1;36m\nAppliance Sync Services: \e[0m\n"

printf "%b" "\e[1;37mAppliance Sync Timer \e[0m\n"
systemctl status appliance-sync.timer | grep Active
printf "%b" "\e[1;37m\nAppliance Sync Service \e[0m\n"
systemctl status appliance-sync.service | egrep 'Active|Process'


printf "%b" "\e[1;35m\nThe above services should be running in a multinode Database HA Setup \e[0m\n"
printf "%b" "\e[1;37m - If it is a single Primary Node or Database HA is not being used, the Sync Service does not need to run \e[0m\n\n"

cd $current




