versions="api/versions"
prov="cloudapi/1.0.0/sessions/provider"
bearer="Authorization: Bearer "

publicaddress=$(sudo -i -u postgres psql vcloud -t -c "select value from config where name = 'restapi.baseUri';" | sed 's/^[ \t]*//;/^$/d;s#^https://##')
publicfull=$(sudo -i -u postgres psql vcloud -t -c "select value from config where name = 'restapi.baseUri';")
eth0=$(ip a show dev eth0 | egrep 'inet' | awk '{print $2}' | sort -r | sed 's/^[ \t]*//' | cut -d/ -f 1)

api="https://$eth0/"

apinoslash="https://$eth0"
apislash="https://$eth0/"

curls="curl -ks -X"

cors="cloudapi/1.0.0/site/settings/cors?page=1&pageSize=25"
version=$(curl -ks -X GET "https://$HOSTNAME/api/versions" | grep "<Version>" | grep -v "alpha" | tail -n 1 | cut -d ">" -f 2 | cut -d "<" -f 1)

#printf "Print Input: $1\n"
#printf "Print Header: $accept\n"

accept="Accept: application/json;version=$version"

#printf "Print Header: $accept\n"

filename='token.txt'

## Main
########

#Login to get Bearer Token
curl -ksSL -D - -X POST "$api$prov" -H "$accept" -u "administrator@system:VMware123!" > headers.txt

cat headers.txt | sed -n '/X-VMWARE-VCLOUD-ACCESS-TOKEN/,/Set-Cookie/{/Set-Cookie/!p}' | cut -d" " -f 2 > token.txt


# Using token print out the current cors setting

while IFS= read -r line
do

 stripped=${line//$'\r'/}

done < "$filename"
printf "\n\n"


token="Authorization: Bearer $stripped"


if [[ $1 =~ "cloudapi" ]] ; then
  accept="Accept: application/json;version=$version"
else
  accept="Accept: application/*+xml;version=$version"
fi

################################################
start=${1::1}
original=$1

if [[ $1 =~ "https"* ]] ; then
  #printf "Full API Provided\n"
  if [[ $1 =~ $publicaddress ]] ; then

  #printf "Public API Provided: $1\n"
  replacedapi=$(echo $1 | sed "s/$publicaddress/$eth0/g")
  #printf "Updated API: $replacedapi\n\n"
  
  elif [[ $1 =~ $hostname ]] ; then
  
  #printf "Hostname API Provided: $1\n"
  replacedapi=$(echo $1 | sed "s/$HOSTNAME/$eth0/g")
  #printf "Updated API: $replacedapi\n\n"
 
  fi

elif [[ $start == '/' ]] ; then 
  #printf "With slash API To Run $1\n"
  replacedapi=$(echo $apinoslash$1)
  original=$(echo $publicfull$1)

elif [[ $Start != '/' ]] ; then
  #printf "Without Slash API To Run $1\n"
  replacedapi=$(echo $apislash$1)
  original=$(echo $publicfull"/"$1)

fi

printf "%b" "\e[1;33mOutput of API\e[0m $replacedapi\n\n"
printf "Header: $accept\n"

if [[ $accept =~ "json" ]] ; then
 curl -ks -X GET "$replacedapi" -H "$accept" -H "$token" | python -mjson.tool
elif [[ $accept =~ "xml" ]] ; then
 curl -ks -X GET "$replacedapi" -H "$accept" -H "$token"
fi

printf "%b" "\e[1;33m\nTimings of Query via Public Address\e[0m $original\n\n"
curl -ks -X GET "$original" -H "$accept" -H "$token" -L --output /dev/null --silent --show-error --write-out 'lookup: %{time_namelookup}\nconnect:  %{time_connect}\nappconnect: %{time_appconnect}\npretransfer:  %{time_pretransfer}\nredirect: %{time_redirect}\nstarttransfer: %{time_starttransfer}\ntotal:  %{time_total}\n'
#python -mjson.tool

printf "%b" "\e[1;33m\nTimings of Query via Cell IP\e[0m $replacedapi\n\n"
curl -ks -X GET "$replacedapi" -H "$accept" -H "$token" -L --output /dev/null --silent --show-error --write-out 'lookup: %{time_namelookup}\nconnect:  %{time_connect}\nappconnect: %{time_appconnect}\npretransfer:  %{time_pretransfer}\nredirect: %{time_redirect}\nstarttransfer: %{time_starttransfer}\ntotal:  %{time_total}\n'
#| python -mjson.tool


echo ""




